# -*- coding: utf-8 -*-
"""
Created on Sat Aug 20 11:09:36 2016

@author: guttag
"""
    
import random
 
def rollDie():
    """returns a random int between 1 and 6"""
    return random.choice([1,2,3,4,5,6])
 
def testRoll(n):
    result = ''
    for i in range(n):
        result = result + str(rollDie())
    return result
#
#random.seed()
#for i in range(10):
#    print(testRoll(5))

def runSim(goal, numTrials):
    total = 0
    for i in range(numTrials):
        if i != 0 and i%1000 == 0:
            print('Starting trial', i)
        result = ''
        for j in range(len(goal)):
            result += str(rollDie())
        if result == goal:
            total += 1
    print('Actual probability of', goal, '=',
          round(1/(6**len(goal)), 8)) 
    estProbability = round(total/numTrials, 8)
    print('Estimated Probability of', goal, '=',
          round(estProbability, 8))

#runSim('11111', 1000)
#runSim('11111', 1000000)

import math

def trueProb(numPeople):
    #assumes each birth date equally probable
    numerator = math.factorial(366)
    denom = (366**numPeople)*math.factorial(366-numPeople)
    return 1 - numerator/denom
#
#for i in (2, 4, 8, 16, 32, 64, 128, 256):
#    print('Probability of a shared birthday with', i,
#          'people =', '%.4f'%trueProb(i))
#    
def sameDate(numPeople, numSame, possibleDates):
    birthdays = [0]*366
    for p in range(numPeople):
        birthDate = random.choice(possibleDates)
        birthdays[birthDate] += 1
    return max(birthdays) >= numSame

def birthdayProb(numPeople, numSame, numTrials,
                 possibleDates):
    numHits = 0
    for t in range(numTrials):
        if t != 0 and t%100000 == 0:
            print('Starting trial', t)
        if sameDate(numPeople, numSame, possibleDates):
            numHits += 1
    return numHits/numTrials

#possibleDates = range(366)
#for i in (2, 4, 8, 16, 32, 64, 128, 256):
#    print('Est. probability of a shared birthday with', i,
#          'people =', '%.4f'%birthdayProb(i, 2, 1000, possibleDates))

#possibleDates = range(366)
#for i in (2, 4, 8, 16, 32, 64, 128, 256):
#    print('Est. probability of three sharing a birthday among', i,
#          'people =', '%.4f'%birthdayProb(i, 3, 1000, possibleDates))


import numpy as np
import matplotlib.pyplot as plt
   
def getBdays():
    inFile = open('Births.csv')
    inFile.readline() #discard first line
    numBirths = [int(line.split(',')[2][:-1])\
                 for line in inFile]
    possibleDates = []
    for i in range(len(numBirths)):
        possibleDates += [i]*(numBirths[i])
    return possibleDates

#random.seed(0)
#
#possibleDates = getBdays()
#numShared = 3 
#for numPeople in [16, 32, 64, 128, 256]:
#    print('For', numPeople, 'probability of',
#          numShared, 'shared birthdays:')
#    print('  Estimated for actual distribution: ',
#          birthdayProb(numPeople, numShared, 10000,
#                       possibleDates))
#    print('  Estimated for uniform distribution:',
#          birthdayProb(numPeople, numShared, 10000,
#                       range(366)))

def plotBdayDist():
    inFile = open('Births.csv')
    inFile.readline() #discard first line
    numBirths = [int(line.split(',')[2][:-1])\
                 for line in inFile]
    d = {i+1:numBirths[i] for i in range(len(numBirths))}
    vals = [d[k] for k in d.keys()]
    plt.plot(vals, 'bo')
    plt.xlim(-10, plt.xlim()[1])
    plt.xlabel('Day of Year')
    plt.ylabel('Number of Births')
    mean = 'Mean = ' + str(int(sum(vals)/len(vals)))
    std = 'Std = ' + str(int(np.std(vals)))
    plt.title('Frequency of Birthdates\n' +
                mean + ', ' + std)

#plotBdayDist()